QuestieCorrections = {}

QuestieCorrections.questFixes = {
    -- add quest 3375 in field 14 (subQuests)
    -- TODO add parentQuest field to database so 3375 knows when not to show as available
    [2201] = {"Find the Gems",{{6912,},nil,nil,},{nil,{112877,},},40,43,77,nil,{"Find the ruby, sapphire, and topaz that are scattered throughout Uldaman.","Once acquired, contact Talvash del Kissel remotely by using the Phial of Scrying he previously gave you.","From the journal, you know...","* The ruby has been stashed in a barricaded Shadowforge area.","* The topaz has been hidden in an urn in one of the Trogg areas, near some Alliance dwarves.","* The sapphire has been claimed by Grimlok, the trogg leader.",},nil,{nil,nil,{{7669,nil},{7670,nil},{7671,nil},},nil,},7668,nil,{2200,},{3375},nil,nil,1517,nil,nil,nil,nil,2204,},
    -- Add 12347 to the sourceItemIds so the objective is shown on the map #798
    [4763] = {"The Blackwood Corrupted",{{3649,},nil,nil,},{{3649,},nil,},15,18,77,nil,{"Fill the Empty Cleansing Bowl at the Auberdine Moonwell.","Gather a sample of fruit, nut, and grain from the northern Blackwood furbolg camps.","Mix the bowl and place it near the bonfire closest to the Cliffspring River at the northern camp, thus summoning the satyr corruptor.","Take the Talisman of Corruption and bring it to Thundris Windweaver in Auberdine.",},nil,{nil,nil,{{12355,nil},},nil,},12346,nil,{4762,},nil,nil,nil,148,nil,nil,nil,{12347,12341,12342,12343,},nil,},

    -- please label what you changed in the entry so its easier to figure out
    -- I still think replacing specific entries instead of the whole quest is a more future proof way of dealing with corrections

    -- change race requirement bitmask to be only alliance (was 255)
    [6132] = {"Get Me Out of Here!",{{12277,},nil,nil,},{{6019,},nil,},34,39,77,nil,{"Escort Melizza Brimbuzzle, then speak with Hornizz Brimbuzzle at the Kodo Graveyard in Desolace.",},nil,{nil,nil,nil,nil,},nil,nil,nil,nil,nil,nil,405,nil,nil,nil,nil,nil,},
    -- add 177528 to requiredSourceItems as addition to #857
    [5721] = {"The Battle of Darrowshire",{{10667,},nil,nil,},{{10926,},nil,},55,60,255,nil,{"Place the Relic Bundle at the Darrowshire town square.","Prevent Davil Lightfire's death until the death of Horgus.","Prevent Captain Redpath's death until Redpath the Corrupted appears.","Defeat Redpath the Corrupted.","Speak with the spirit of Joseph Redpath when he appears at the town square, then speak with Pamela at her home.",},nil,{{{10936,"Accept Redpath's Forgiveness"},},nil,nil,nil,},15209,nil,{5941,},nil,nil,nil,139,nil,nil,nil,{177528,},5942,},
    -- fix race requirement bitmask to be only horde (was 255)
    [858] = {"Ignition",{{3439,},nil,nil,},{{3439,},nil,},13,18,178,nil,{"Get the Ignition Key and bring it to Wizzlecrank.",},nil,{nil,nil,{{5050,nil},},nil,},nil,nil,nil,nil,nil,nil,17,nil,nil,nil,nil,nil,},
    -- fix race requirement bitmask to be horde (was 16) #888
    [367] = {"A New Plague",{{1518,},nil,nil,},{{1518,},nil,},6,6,178,nil,{"Apothecary Johaan in the town of Brill wants you to collect 5 Vials of Darkhound Blood.",},nil,{nil,nil,{{2858,nil},},nil,},nil,nil,nil,nil,nil,nil,85,nil,nil,nil,nil,368,},
    [368] = {"A New Plague",{{1518,},nil,nil,},{{1518,},nil,},6,9,178,nil,{"Apothecary Johaan of the town of Brill needs 5 Vile Fin Scales from Murlocs in Tirisfal Glades.",},nil,{nil,nil,{{2859,nil},},nil,},nil,nil,{367,},nil,nil,nil,85,nil,nil,nil,nil,369,},
    [369] = {"A New Plague",{{1518,},nil,nil,},{{1518,},nil,},6,11,178,nil,{"Apothecary Johaan in the town of Brill wants you to bring him 4 samples of venom from a Vicious Night Web Spider.",},nil,{nil,nil,{{2872,nil},},nil,},nil,nil,{368,},nil,nil,nil,85,nil,nil,nil,nil,492,},
    -- Fix race requirement bitmask to orc (was 178) #813
    [3090] = {"Tainted Parchment",{{3143,},nil,nil,},{{3156,},nil,},1,1,2,256,{"Read the Tainted Parchment and speak to Nartok inside the Den in the Valley of Trials.",},nil,{nil,nil,nil,nil,},9579,nil,{788,},nil,nil,nil,-61,nil,nil,nil,nil,nil,nil,nil,nil,},
    -- Switch Alliance and Horde Druid quest IDs #948
    [26] = {
        [QuestieDB.questKeys.startedBy] = {{4217,},nil,nil,},
        [QuestieDB.questKeys.requiredRaces] = 8,
        [QuestieDB.questKeys.nextQuestInChain] = 29,
    },
    [27] = {
        [QuestieDB.questKeys.startedBy] = {{3033,},nil,nil,},
        [QuestieDB.questKeys.requiredRaces] = 32,
        [QuestieDB.questKeys.nextQuestInChain] = 28,
    },
    [7068] = {
        [QuestieDB.questKeys.requiredLevel] = 39,
    },
    [7070] = {
        [QuestieDB.questKeys.requiredLevel] = 39,
    },
    -- Save Techbot's Brain does not need the Tinkmaster Overspark breadcrumb #687
    [2922] = {
        [QuestieDB.questKeys.preQuestSingle] = {},
    },
    [1276] = {
        [QuestieDB.questKeys.preQuestSingle] = {1323,1273,},
    },
    [4641] = {
        [QuestieDB.questKeys.requiredRaces] = 178, -- #877
    },
    [1204] = {
        [QuestieDB.questKeys.preQuestSingle] = {}, -- #938
    },
    [4494] = {
        [QuestieDB.questKeys.preQuestSingle] = {82}, -- #942
    },
    [282] = {
        [QuestieDB.questKeys.exclusiveTo] = {287}, -- #881
    },
    [1127] = {
        [QuestieDB.questKeys.specialFlags] = 1, -- #884
    },
    [1275] = {
        [QuestieDB.questKeys.preQuestSingle] = {}, -- #973
    },
    [3449] = {
        [QuestieDB.questKeys.childQuests] = {3451}, -- #1008
    },
    [3451] = {
        [QuestieDB.questKeys.parentQuest] = {3449}, -- #1008
    },
}

QuestieCorrections.npcFixes = {
    [300] = {'Zzarc\' Vul',1050,1050,33,33,0,{[10]={{38,80},},},nil,10,nil,nil},
    [5082] = {'Vincent Hyal',1605,1605,30,30,0,{[11]={{10.8,60.4}}},nil,11,{1302},{1301}},
    [4360] = {'Mirefin Warrior',1208,1257,37,39,0,{},nil,15,nil,nil}, -- TODO: remove this after the db is fixed!!! This is just to fix tooltips
    [11876] = {'Demon Spirit',1743,1743,37,37,0,{[405]={{55.00,26.60},},},nil,405,nil,nil,92,nil,},
    [12297] = {'Sickly Gazelle',14,14,3,3,0,{[17]={{48.8,23.8},{42.47,20.49},{51.15,38.53},{48.11,14.51},{42.81,15.28},{59.18,17.75},{42.74,36.02},{41.18,25.68},{54.41,21.93},{54.67,29.98},{51.74,20.44},{57.68,20.79},{50.52,13.04},{52.4,14.28},{46.08,29.96},{53.45,20.8},{45.44,26.66},{56.93,38.97},{44.71,33.76},{50.18,23.26},{60.29,28.13},{58.03,37.06},{53.81,12.23},{57.36,18.14},{41.49,22.7},{54.67,10.57},{44.2,19.76},{56.61,16.61},{52.77,18.57},{56.65,18.12},{48.32,26.34},{44.52,17.61},{40.81,20.67},{59.94,31.01},{43.27,28.12},{48.76,36.48},{52.42,12.74},{43.74,39.33},{49.26,27.23},{54.99,13.34},{47.0,24.16},{58.44,34.68},{45.53,14.75},{60.32,35.27},{51.02,19.46},{50.39,15.37},{57.43,33.98},{54.5,32.09},{53.44,26.84},{50.47,35.75},{50.01,31.15},{48.77,29.55},{55.09,35.44},{54.99,38.7},{53.28,37.96},{58.22,23.88},{49.96,31.05},{50.7,35.92},{48.71,36.9},{54.25,24.17},{54.3,21.78},{57.59,20.49},{58.72,22.12},{60.27,21.63},},},{[14]={{17.44,47.56},{17.34,48.09},{17.29,48.36},{17.38,48.57},{17.63,48.66},{18.06,48.63},{18.58,48.54},{18.6,48.22},{18.62,47.86},{18.65,47.58},{18.76,47.16},{18.82,46.97},{18.89,46.61},{18.8,46.15},{18.58,45.84},{18.19,46.0},{17.95,46.2},{17.82,46.53},{17.65,47.38},{9.38,50.08},{9.12,50.04},{8.66,50.09},{8.01,50.19},{7.82,49.93},{7.61,49.37},{7.75,49.39},{8.11,49.46},{8.88,49.22},{9.37,49.21},{10.28,49.43},{10.54,49.65},{10.42,49.97},{10.17,50.13},{9.82,50.13},{23.67,44.89},{23.52,44.47},{23.25,44.05},{23.03,43.83},{22.81,43.61},{22.53,43.25},{22.47,42.84},{22.62,42.44},{22.84,42.5},{23.05,42.71},{23.31,43.18},{23.6,43.3},{23.87,43.33},{24.24,43.41},{24.46,43.62},{24.61,43.98},{24.66,44.44},{24.57,44.82},{24.38,45.07},{24.13,45.16},{23.71,45.18},},[17]={{54.35,21.92},{54.3,22.19},{54.27,22.33},{54.32,22.44},{54.45,22.49},{54.68,22.47},{54.94,22.42},{54.96,22.26},{54.97,22.07},{54.98,21.93},{55.04,21.71},{55.07,21.61},{55.11,21.42},{55.06,21.18},{54.95,21.02},{54.74,21.1},{54.62,21.21},{54.55,21.38},{54.46,21.82},{50.15,23.23},{50.01,23.21},{49.77,23.23},{49.43,23.29},{49.33,23.15},{49.22,22.86},{49.3,22.87},{49.48,22.91},{49.89,22.78},{50.14,22.77},{50.62,22.89},{50.75,23.0},{50.69,23.17},{50.56,23.26},{50.38,23.25},{57.6,20.52},{57.52,20.3},{57.38,20.09},{57.27,19.97},{57.15,19.86},{57.0,19.67},{56.97,19.45},{57.05,19.24},{57.17,19.28},{57.28,19.38},{57.42,19.63},{57.57,19.69},{57.7,19.71},{57.9,19.75},{58.01,19.86},{58.09,20.05},{58.12,20.29},{58.07,20.49},{57.97,20.62},{57.84,20.66},{57.62,20.67},},},17,nil,nil,188,"AH",},
    [12299] = {'Sickly Deer',20,20,5,5,0,{[148]={{44.48,24.36},{35.17,89.26},{46.56,24.97},{34.57,87.25},{38.36,77.52},{36.19,81.94},{44.56,27.62},{43.7,64.03},{46.81,51.18},{46.17,48.28},{41.95,69.65},{45.02,44.31},{39.1,61.87},{46.99,44.1},{43.62,31.44},{46.0,41.38},{41.85,38.14},{43.97,52.89},{40.08,69.85},{42.2,73.37},{43.07,75.47},{43.97,80.14},{47.14,42.21},{47.17,41.27},{45.82,41.49},{38.56,36.07},{43.77,41.38},{48.13,33.97},{46.92,33.91},{45.56,31.68},{43.18,88.41},{39.11,89.9},{40.67,89.83},{41.02,77.81},{49.48,35.21},{49.11,36.08},{41.44,52.68},{41.04,34.8},{51.1,33.53},{51.92,32.75},{41.23,48.31},{38.57,59.21},{40.3,81.84},{38.92,70.36},{51.18,29.79},{49.48,28.58},{41.5,46.08},{38.68,54.53},{40.84,60.16},{47.68,27.5},{43.53,83.42},{43.35,40.79},{42.3,39.6},{40.34,52.3},{43.28,66.94},{37.06,91.2},{39.09,47.85},{43.81,48.22},{48.17,38.98},},},nil,148,nil,nil,188,"AH",},
    [5600] = {'Khan Dez\'hepah',1341,1341,35,35,0,{[405]={{73.2,41.8},{73.4,43},{74,43.6},{74.4,44.8},{73.6,46.6},{73,47.8},{74.6,48.8},},},nil,405,nil,nil,130,nil,},
    [6569] = {'Gnoarn',919,919,20,20,0,{[1537]={{69.5,50.6},},},nil,1537,{2039,2041,2927,},nil,55,"A",}, -- Dun Morogh -> Ironforge for #708
    -- Copy spawns of unzapped mobs to zapped ones to fix #892
    [14603] = {'Zapped Shore Strider',2873,2884,48,49,0,{[357]={{34.54,33.98},{42.52,46.88},{38.25,34.95},{36.47,35.75},{36.42,36.53},{45.46,62.32},{44.15,50.09},{45.9,57.9},{46.49,59.58},},},nil,357,nil,nil,14,nil,},
    [14604] = {'Zapped Land Walker',3294,3294,48,48,0,{[357]={{40.93,25.55},{38.07,18.26},{37.99,23.6},{39.61,22.11},{37.76,21.92},{39.16,23.89},{38.52,24.39},{41.15,24.82},},},nil,357,nil,nil,14,nil,},
    [14638] = {'Zapped Wave Strider',2779,2841,47,48,0,{[357]={{45.1,61.95},{37.71,34.47},{44.34,46.61},{46.78,57.88},},},nil,357,nil,nil,14,nil,},
    [14639] = {'Zapped Deep Strider',2282,2479,47,49,0,{[357]={{36.14,33.44},{43.13,52.95},{40.15,38.65},{44.99,66.44},{44.12,49.08},{45.23,52.9},{46.83,62.22},},},nil,357,nil,nil,14,nil,},
    [14640] = {'Zapped Cliff Giant',3092,3092,49,49,0,{[357]={{39.9,21.9},{40.44,22.43},{40.32,24.63},{40.72,24.44},{38.69,23.6},{39.67,22.3},{38.78,21.93},{38.23,20.59},{38.17,21.4},{41.05,22.62},{39.62,22.23},},},nil,357,nil,nil,778,nil,},
    [13017] = {'Deeprun Rat',1,1,1,1,0,{},nil,0,nil,nil,188,"AH"},
    [11122] = {'Restless Soul',42,42,1,1,0,{},nil,0,nil,nil,35,"AH",}, -- #919
    [12369] = {'Lord Kragaru',1604,1604,38,38,0,{[405]={{28.6,7.4}}},nil,0,nil,nil,14,nil,}, -- Add spawn to show objective point #901
    -- Remove wrong patrolling zones on those two (found while investigating #903)
    [446] = {'Redridge Basher',417,449,19,20,0,{[44]={{32.44,29.17},{32.29,29.38},{28.32,30.49},{28.89,30.16},{27.49,27.37},{27.38,29.43},{29.87,31.19},{28.55,31.48},{19.53,21.68},{23.73,29.13},{19.51,23.92},{21.94,15.29},{17.57,19.85},{18.63,18.15},{19.38,25.88},{23.11,18.3},{18.35,23.13},{16.7,21.92},{20.47,29.91},{17.9,19.45},{28.26,28.43},{28.31,27.8},{28.7,25.63},{34.09,25.26},{34.3,25.0},{35.22,25.76},{31.91,24.02},{23.56,25.24},{23.38,25.38},{23.51,26.23},{23.3,26.75},{23.46,24.15},{35.33,27.98},{30.98,22.78},{34.04,24.8},},},{[44]={{23.51,26.77},{23.73,29.13},{24.21,30.93},{23.73,29.13},{19.82,30.28},{19.44,30.78},{19.42,31.63},{19.44,30.78},{19.82,30.28},{20.47,29.91},{20.82,29.36},{20.88,28.23},{20.11,27.76},{19.3,25.56},{18.8,24.44},{19.04,23.74},{19.45,21.99},{19.04,23.74},{18.8,24.44},{19.29,25.52},{20.11,27.76},{20.88,28.23},{20.82,29.36},{20.47,29.91},{18.53,20.34},{19.18,20.53},{19.72,20.45},{20.24,20.71},{20.45,21.2},{20.42,21.78},{20.45,21.21},{20.24,20.71},{19.72,20.45},{19.18,20.53},{18.53,20.34},{17.9,19.45},{16.72,19.28},{15.8,18.95},{15.85,20.7},{16.37,21.75},{17.54,22.69},{16.37,21.75},{15.85,20.7},{15.8,18.95},{16.72,19.28},{17.9,19.45},},},44,nil,nil,19,nil,},
    [580] = {'Redridge Drudger',494,531,20,21,0,{[44]={{16.07,17.13},{20.29,21.05},{15.89,21.17},{15.96,18.87},{19.96,27.48},{21.63,23.63},{21.28,17.37},{22.35,20.55},{20.2,13.23},{18.73,15.3},{22.26,16.55},{18.82,24.3},{17.04,17.92},{18.54,15.22},},},{[44]={{17.73,15.61},{18.54,15.22},{18.88,14.35},{19.46,13.61},{20.55,13.37},{21.62,14.63},{22.28,15.88},{21.62,14.63},{20.55,13.37},{19.46,13.61},{18.88,14.35},{18.54,15.22},},},44,nil,nil,19,nil,},
    [9683] = {'Lar\'korwi Mate',2583,2694,49,50,0,{[490]={{58,78},{60,72},{62,65},{62,80},{63,77},{66,62},{66,66},{67,60},{67,73},{67,67},{70,60},{71,59},},},nil,490,nil,nil,48,nil,},
    [10936] = {'Joseph Redpath',3857,3857,60,60,0,{[139]={{39.2,91.33},},},nil,139,nil,nil,35,"AH",},
    [12576] = {'Grish Longrunner',706,706,25,25,0,{[400]={{31.86,21.66},},[17]={{44.0,92.0}},},nil,400,nil,{5881,},104,"H",}, -- Add spawn in The Barrens to be shown on the map
}

QuestieCorrections.objectFixes = {
    [92423] = {"Damaged Chest",nil,nil,{[400]={{43.4, 32.7}},[17]={{49.02,96.77}}},400},
    [167] = {"Abercrombie's Crate",nil,nil,{[10]={{33.42,76.35}}},10},
    [19021] = {"Rusty Chest",nil,nil,{[331]={{69.04,84.77},{77.03,73.8},{79.08,74.48},{70.53,73.58},{70.68,85.06},{69.29,82.67},{71.29,83.83},{77.97,65.82},{77.38,69.77},{77.06,68.3},{69.87,74.11},{78.3,73.6},{76.22,67.48},{76.62,70.67},{76.77,72.19},{78.31,69.73},{68.24,77.68},{77.68,72.63},{74.77,69.6},{78.26,64.58},{70.72,75.24},{74.23,69.47},{74.36,70.21},{75.88,73.52},{75.87,69.99},{69.89,85.32},{74.34,77.92},{70.1,76.08},{74.58,77.19},{74.67,75.39},{76.67,68.46},{68.94,84.86},{74.41,73.38},{74.46,75.56},{73.09,73.23},{71.04,73.8},{71.45,76.97},{73.68,76.95},{72.63,76.86},{70.77,75.99},{72.51,75.12}}},331},
    [2867] = {"Excavation Supply Crate",nil,nil,{[3]={{66.6,22}}},3}, -- position was slightly off
    [154357] = {"Glinting Mud",nil,nil,{[44]={{38.04,54.49},{19.16,51.74},{34.13,53.37},{29.52,53.72},{21.79,53.17},},},44,},
    [144052] = {"Sandsorrow Watch Water Hole",nil,nil,{[440]={{39,29}}},440,},
}

-- [item ID] = {"name",{objective of},{dropped by},{contained in/gathered from/mined from}}
QuestieCorrections.itemFixes = {
    [5475] = {"Wooden Key",{},{3919,3834},{}},
    [5519] = {"Iron Pommel",{1027},{3928},{}},
    [4611] = {"Blue Pearl",{705},{},{2744}},
    [3340] = {"Incendicite Ore",{466},{},{1610,1667}},
    [4483] = {"Burning Key",{651},{},{2689}},
    [3829] = {"Frost Oil",{713,1193},{},{}},
    [15843] = {"Filled Dreadmist Peak Sampler",{6127},{},{19464}},
    [15845] = {"Filled Cliffspring Falls Sampler",{6122},{},{19463}},
    [17124] = {"Syndicate Emblem",{},{2246,2590,2240,2586,2589,2587,2588,2242,2241,2319,2261,2244,2260},{}},
    [8072] = {"Silixiz's Tower Key",{},{7287},{}},
    [7923] = {"Defias Tower Key",{2359},{7051},{}},
    [7675] = {"Defias Shipping Schedule",{},{6846},{}},
    [7737] = {"Sethir's Journal",{},{6909},{}},
    [7208] = {"Tazan's Key",{},{6466},{}},
    [12347] = {"Filled Cleansing Bowl",{},{},{174795}},
    [2886] = {"Crag Boar Rib",{384},{1125,1126,1127,1689},{}},
    [5051] = {"Dig Rat",{862},{3444},{}},
    [5056] = {"Root Sample",{866},{},{1619,3726,1618,3724,1620,3727}},
    [12349] = {"Cliffspring River Sample",{4762},{},{175371}},
    [12350] = {"Empty Sampling Tube",{4762},{},{}},
    [5184] = {"Filled Crystal Phial",{921},{},{19549}},
    [5185] = {"Crystal Phial",{921},{},{}},
    [5186] = {"Partially Filled Vessel",{928},{},{}},
    [5639] = {"Filled Jade Phial",{929},{},{19550}},
    [5619] = {"Jade Phial",{929},{},{}},
    [5645] = {"Filled Tourmaline Phial",{933},{},{19551}},
    [5621] = {"Tourmaline Phial",{933},{},{}},
    [18151] = {"Filled Amethyst Phial",{7383},{},{19552}},
    [18152] = {"Amethyst Phial",{7383},{},{}},
    [5188] = {"Filled Vessel",{935},{},{}},
    [11184] = {"Blue Power Crystal",{4284,4382,4384,4386},{},{164658,164778}},
    [11185] = {"Green Power Crystal",{4284,4381,4382,4383},{},{164659,164779}},
    [11186] = {"Red Power Crystal",{4284,4383,4384,4385},{},{164660,164780}},
    [11188] = {"Yellow Power Crystal",{4284,4381,4385,4386},{},{164661,164781}},
    -- add NPC 1988 (missing in cmangos) and object 152094 (present in cmangos)
    [10639] = {"Hyacinth Mushroom",{3521},{1988,1989},{152094}},
    [14338] = {"Empty Water Tube",{4812},{},{}},
    [15209] = {"Relic Bundle",{5721},{},{}},
    [14339] = {"Moonwell Water Tube",{4812},{},{174795}},
    [8584] = {"Untapped Dowsing Widget",{992},{},{}},
    [8585] = {"Tapped Dowsing Widget",{992},{},{144052}},
    [11149] = {"Samophlange Manual",{3924},{},{}},
    [11018] = {"Un\'Goro Soil",{4496,3761,3764},{},{157936}},
    [6435] = {"Infused Burning Gem",{1435},{4663,4664,4665,4666,4667,4668,4705,13019},{}},
    [3388] = {"Strong Troll's Brool Potion",{515},{},{}},
    [3508] = {"Mudsnout Mixture",{515},{},{}},
    [4904] = {"Venomtail Antidote",{812},{},{}},
    [2594] = {"Flagon of Dwarven Honeymead",{288},{1464},{}},
    [5868] = {"Filled Etched Phial",{1195},{},{20806}},
    [16642] = {"Shredder Operating Manual - Chapter 1",{6504},{},{}},
    [16643] = {"Shredder Operating Manual - Chapter 2",{6504},{},{}},
    [16644] = {"Shredder Operating Manual - Chapter 3",{6504},{},{}},
    [16764] = {"Warsong Scout Update",{6543},{},{}},
    [16763] = {"Warsong Runner Update",{6543},{},{}},
    [16765] = {"Warsong Outrider Update",{6543},{},{}},
    [1013] = {"Iron Rivet",{89},{426,430,446,580},{}}, -- Remove rare mob #903
    [2856] = {"Iron Pike",{89},{426,430,446,580},{}}, -- Remove rare mob #903
    [11131] = {"Hive Wall Sample",{3883},{},{174793}},
    [5455] = {"Divined Scroll",{1016},{},{}},
    [9440] = {"Acceptable Basilisk Sample",{654},{},{}},
    [9441] = {"Acceptable Hyena Sample",{654},{},{}},
    [9438] = {"Acceptable Scorpid Sample",{654},{},{}},
    [8523] = {"Field Testing Kit",{654},{7683},{}},
    [9330] = {"Snapshot of Gammerita",{2944},{7977},{}},
    [11113] = {"Crate of Foodstuffs",{3881},{},{161526}},

    -- quest related herbs
    [2449] = {"Earthroot",{6123,6128},{},{1619,3726}},
    [2447] = {"Peacebloom",{8549,8550},{},{1618,3724}},
    [8846] = {"Gromsblood",{4201},{},{142145,176637}},
    [3356] = {"Kingsblood",{7736},{},{1624}},
    [3357] = {"Liferoot",{1712},{},{2041}},
    [8836] = {"Arthas' Tears",{8509,8510,7642},{},{142141,176642}},
    [4625] = {"Firebloom",{8580,8581},{},{2866}},
    [3820] = {"Stranglekelp",{8503,8504},{},{2045}},
    [8831] = {"Purple Lotus",{8505,8506,8582,8583},{},{142140,180165}},

    -- quest related leather
    [4304] = {"Thick Leather",{8515,8516,8590,8591,2847,2854},{},{}},
    [4234] = {"Heavy Leather",{8242,8588,8589},{},{}},
    [2318] = {"Light Leather",{8511,8512,768,769},{},{}},
    [2319] = {"Medium Leather",{8513,8514},{},{}},
    [8170] = {"Rugged Leather",{8600,8601,5518,5519},{},{}},

    -- quest related mining stuff
    [11370] = {"Dark Iron Ore",{6642,7627},{},{165658}},
    [1206] = {"Moss Agate",{2948,2950},{},{}},
    [12364] = {"Huge Emerald",{8779,8807},{},{}},
    [1529] = {"Jade",{1948},{},{}},
    [7910] = {"Star Ruby",{4083,5124},{},{}},
    [3864] = {"Citrine",{2763},{},{}},

    -- other quest related trade goods
    [2592] = {"Wool Cloth",{7791,7797,7802,7807,7813,7820,7826,7833},{},{}},
    [2997] = {"Bolt of Woolen Cloth",{565},{},{}},
    [4306] = {"Silk Cloth",{9259,2746,4449,7793,7798,7803,7808,7814,7821,7827,7834},{},{}},
    [4338] = {"Mageweave Cloth",{9268,7794,7799,7804,7809,7817,7822,7831,7835},{},{}},
    [2589] = {"Linen Cloth",{9267,1644,1648,1921,1961},{},{}},
    [14047] = {"Runecloth",{9266,5218,5221,5224,5227,6031,7642,7795,7796,7800,7801,7805,7806,7811,7812,7818,7819,7823,7824,7825,7832,7836,7837},{},{}},
    [14048] = {"Bolt of Runecloth",{8782,8808,9237,9238,9239,9240,5518,5519},{},{}},
}

-- some quest items are shared across factions but require different sources for each faction (not sure if there is a better way to implement this)
QuestieCorrections.itemFixesHorde = {
    [15882] = {"Half Pendant of Aquatic Endurance",{30,272},{},{177790}},
    [15883] = {"Half Pendant of Aquatic Agility",{30,272},{},{177794}},
    [3713] = {"Soothing Spices",{},{2397,8307},{}},
}

QuestieCorrections.itemFixesAlliance = {
    [15882] = {"Half Pendant of Aquatic Endurance",{30,272},{},{177844}},
    [15883] = {"Half Pendant of Aquatic Agility",{30,272},{},{177792}},
    [3713] = {"Soothing Spices",{},{2381,4897},{}},
}

if UnitFactionGroup("Player") == "Horde" then
    for index, fix in pairs(QuestieCorrections.itemFixesHorde) do
        QuestieCorrections.itemFixes[index] = fix
    end
else
    for index, fix in pairs(QuestieCorrections.itemFixesAlliance) do
        QuestieCorrections.itemFixes[index] = fix
    end
end

QuestieCorrections.questRequirementFixes = {
    [46] = {39},
    [3903] = {18},
    [33] = {783},
    [374] = {427}, -- proof of demise requires at war with the scarlet crusade
    [1106] = {1104, 1105},
    [431] = {366}, -- #638
    [410] = {366}, -- #638
    [926] = {809}, -- #606
    [364] = {}, -- #882
    [1275] = {}, -- #745 prequest is not required in Classic
    [1302] = {}, -- #889
    [473] = {455}, -- #809
}

QuestieCorrections.questExclusiveGroupFixes = {
    [463] = {276}, --greenwarden cant be completed if you have trampling paws
    [415] = {413}, --cant complete rejolds new brew if you do shimmer stout (see issue 567)
    [1339] = {1338}, -- mountaineer stormpike's task cant be done if you have finished stormpike's order
    [1943] = {1944}, -- mage robe breadcrumb
    [526] = {322,324}, -- not 100% sure on this one but it seems lightforge ingots is optional, block it after completing subsequent steps (#587)
    [3765] = {1275}, -- corruption abroad breadcrumb
    [164] = {95}, -- deliveries to sven is a breadcrumb
    -- this is a subquest
    --[403] = {311}, -- completing the unguarded barrel quest prevents to do the optional guarded barrel prequest
    [428] = {429}, -- lost deathstalkers breadcrumb
    [308] = {311}, -- distracting jarven can't be completed once you get the followup
    -- Tome of Divinity starting quests for dwarfs #703
    [1645] = {1642,1646,2997,2998,2999,3000,3681}, -- This is repeatable giving an item starting 1646
    [1646] = {1642,2997,2998,2999,3000,3681},
    [2997] = {1642,1646,2998,2999,3000,3681},
    [2999] = {1642,1646,2997,2998,3000,3681},
    [3000] = {1642,1646,2997,2998,2999,3681},
    -- Tome of Divinity starting quests for humans #703
    [1641] = {1642,1646,2997,2998,2999,3000,3861}, -- This is repeatable giving an item starting 1642
    [1642] = {1646,2997,2998,2999,3000,3861},
    [2998] = {1642,1646,2997,2998,3000,3861},
    [3861] = {1642,1646,2997,2998,2999,3000},
    -- Tome of Valor repeatable starting quests #742
    [1793] = {1649},
    [1794] = {1649},
    [431] = {411}, -- candles of beckoning
    [410] = {411}, -- the dormant shade
    -- Tome of Nobility quests #1661
    [1661] = {4485,4486},
    [4485] = {1661,4486},
    [4486] = {1661,4485},
    -- Voidwalker questline for horde
    [1473] = {1501},
    [1501] = {1473},
    [163] = {5}, -- Raven Hill breadcrumb
    [1301] = {1302}, -- breadcrumb of James Hyal #917
}

QuestieCorrections.questItemBlacklist = {
    [2589] = true, -- linen cloth
    [2592] = true, -- wool cloth
    [4306] = true, -- silk cloth
    [4338] = true, -- mageweave
    [14047] = true, -- runecloth
    [2997] = true, -- bolt of wool
    [14048] = true, -- bolt of runecloth
    [1529] = true, -- jade
    [12363] = true, -- arcane crystal
    [12800] = true, -- azerothian diamond
    [12364] = true, -- huge emerald
    [12361] = true, -- blue sapphire
    [12799] = true, -- large opal
    [7910] = true, -- star ruby
    [7909] = true, -- aquamarine
    [3864] = true, -- citrine
    [1705] = true, -- lesser moonstone
    [1206] = true, -- moss agate
    [1210] = true, -- shadowgem
    [774] = true, -- malachite
    [5056] = true, -- root sample
    [2449] = true, -- earthroot
    [2447] = true, -- peacebloom
    [765] = true, -- silverleaf
    [785] = true, -- mageroyal
    [2450] = true, -- briarthorn
    [2452] = true, -- swiftthistle
    [2453] = true, -- bruiseweed
    [3820] = true, -- stranglekelp
    [3355] = true, -- wild steelbloom
    [3369] = true, -- grave moss
    [3356] = true, -- kingsblood
    [3357] = true, -- liferoot
    [3818] = true, -- fadeleaf
    [3821] = true, -- goldthorn
    [3358] = true, -- khadgar's whisker
    [3819] = true, -- wintersbite
    [8153] = true, -- wildvine
    [4625] = true, -- firebloom
    [8831] = true, -- purple lotus
    [8836] = true, -- arthas tears
    [8838] = true, -- sungrass
    [8839] = true, -- blindweed
    [8845] = true, -- ghost mushroom
    [8846] = true, -- gromsblood
    [13464] = true, -- golden sansam
    [13463] = true, -- dreamfoil
    [13465] = true, --mountain silversage
    [13466] = true, -- plaguebloom
    [13467] = true, -- icecap
    [13468] = true, -- black lotus

    -- stranglethorn pages
    [2725] = true,
    [2728] = true,
    [2730] = true,
    [2732] = true,
    [2734] = true,
    [2735] = true,
    [2738] = true,
    [2740] = true,
    [2742] = true,
    [2744] = true,
    [2745] = true,
    [2748] = true,
    [2749] = true,
    [2750] = true,
    [2751] = true,

    -- shredder operating manual
    [16645] = true,
    [16654] = true,
    [16655] = true,
    [16656] = true,
    [16646] = true,
    [16647] = true,
    [16648] = true,
    [16649] = true,
    [16650] = true,
    [16651] = true,
    [16652] = true,
    [16653] = true,


    [12207] = true, -- giant egg
    [8932] = true, -- Alterac Swiss
}

--hack
for k,v in pairs(QuestieCorrections.itemFixes) do CHANGEME_Questie4_ItemDB[k]=v; end

QuestieCorrections.questHiddenFixes = {
    [1026] = {5475} -- wooden key
}

QuestieCorrections.hiddenQuests = {
  [1878] = true, -- Repeatable version of 1707 - Fixing #775
  [2881] = true, -- Repeatable version of 2880
  [5663] = true, -- Touch of Weakness of Dark Cleric Beryl - Fixing #730
  [7725] = true, -- Repeatable version of 7003 - Fixing #891
  [7726] = true, -- Repeatable version of 7721 - Fixing #891
  [2358] = true, -- Horns of Nez'ra is not in the game at this point. See #921
  [787] = true, -- The New Horde is not in the game. See #830
  --Stray quests
  [3861] = true, --CLUCK!
  --World event quests
  --Fetched from https://classic.wowhead.com/world-event-quests
  [7904] = true,
  [8571] = true,
  [7930] = true,
  [7931] = true,
  [7935] = true,
  [7932] = true,
  [7933] = true,
  [7934] = true,
  [7936] = true,
  [7981] = true,
  [7940] = true,
  [8744] = true,
  [8803] = true,
  [8768] = true,
  [8788] = true,
  [8767] = true,
  [9319] = true,
  [9386] = true,
  [7045] = true,
  [6984] = true,
  [9365] = true,
  [9339] = true,
  [8769] = true,
  [171] = true,
  [5502] = true,
  [7885] = true,
  [8647] = true,
  [7892] = true,
  [8715] = true,
  [8719] = true,
  [8718] = true,
  [8673] = true,
  [8726] = true,
  [8866] = true,
  [925] = true,
  [7881] = true,
  [7882] = true,
  [8353] = true,
  [8354] = true,
  [172] = true,
  [1468] = true,
  [8882] = true,
  [8880] = true,
  [7889] = true,
  [7894] = true,
  [1658] = true,
  [7884] = true,
  [8357] = true,
  [8360] = true,
  [8648] = true,
  [8677] = true,
  [7907] = true,
  [7906] = true,
  [7929] = true,
  [7927] = true,
  [7928] = true,
  [8683] = true,
  [910] = true,
  [8684] = true,
  [8868] = true,
  [8862] = true,
  [7903] = true,
  [8727] = true,
  [8863] = true,
  [8864] = true,
  [8865] = true,
  [8878] = true,
  [8877] = true,
  [8356] = true,
  [8359] = true,
  [9388] = true,
  [9389] = true,
  [911] = true,
  [8222] = true,
  [8653] = true,
  [8652] = true,
  [6961] = true,
  [7021] = true,
  [7024] = true,
  [7022] = true,
  [7023] = true,
  [7896] = true,
  [7891] = true,
  [8679] = true,
  [8311] = true,
  [8312] = true,
  [8646] = true,
  [7890] = true,
  [8686] = true,
  [8643] = true,
  [8149] = true,
  [8150] = true,
  [8355] = true,
  [8358] = true,
  [8651] = true,
  [558] = true,
  [8881] = true,
  [8879] = true,
  [1800] = true,
  [8867] = true,
  [8722] = true,
  [7897] = true,
  [8762] = true,
  [8746] = true,
  [8685] = true,
  [8714] = true,
  [8717] = true,
  [7941] = true,
  [7943] = true,
  [7939] = true,
  [8223] = true,
  [7942] = true,
  [8619] = true,
  [8724] = true,
  [8861] = true,
  [8860] = true,
  [8723] = true,
  [8645] = true,
  [8654] = true,
  [8678] = true,
  [8671] = true,
  [7893] = true,
  [8725] = true,
  [8322] = true,
  [8409] = true,
  [8636] = true,
  [8670] = true,
  [8642] = true,
  [8675] = true,
  [8720] = true,
  [8682] = true,
  [7899] = true,
  [8876] = true,
  [8650] = true,
  [7901] = true,
  [7946] = true,
  [8635] = true,
  [1687] = true,
  [8716] = true,
  [8713] = true,
  [8721] = true,
  [9332] = true,
  [9331] = true,
  [9324] = true,
  [9330] = true,
  [9326] = true,
  [9325] = true,
  [1657] = true,
  [7042] = true,
  [6963] = true,
  [8644] = true,
  [8672] = true,
  [8649] = true,
  [1479] = true,
  [7063] = true,
  [7061] = true,
  [9368] = true,
  [9367] = true,
  [8763] = true,
  [8799] = true,
  [8873] = true,
  [8874] = true,
  [8875] = true,
  [8870] = true,
  [8871] = true,
  [8872] = true,
  [8373] = true,
  [7062] = true,
  [6964] = true,
  [1558] = true,
  [7883] = true,
  [7898] = true,
  [8681] = true,
  [7900] = true,
  [6962] = true,
  [7025] = true,
  [8883] = true,
  [7902] = true,
  [7895] = true,
  [9322] = true,
  [9323] = true,
  [8676] = true,
  [8688] = true,
  [8680] = true,
  [8828] = true,
  [8827] = true,
  [8674] = true,
  [915] = true,
  [4822] = true,
  [7043] = true,
  [6983] = true,
  [7937] = true,
  [7938] = true,
  [7944] = true,
  [7945] = true,
  --Commendation Signet
  [8811] = true,
  [8820] = true,
  [8843] = true,
  [8841] = true,
  [8839] = true,
  [8837] = true,
  [8835] = true,
  [8833] = true,
  [8831] = true,
  [8826] = true,
  [8825] = true,
  [8824] = true,
  [8823] = true,
  [8822] = true,
  [8821] = true,
  [8819] = true,
  [8812] = true,
  [8844] = true,
  [8842] = true,
  [8840] = true,
  [8838] = true,
  [8836] = true,
  [8834] = true,
  [8832] = true,
  [8830] = true,
  [8818] = true,
  [8817] = true,
  [8816] = true,
  [8815] = true,
  [8814] = true,
  [8813] = true,
  [8845] = true,
  --love is in the air
  [8903] = true,
  [8904] = true,
  [8897] = true,
  [8898] = true,
  [8899] = true,
  --Rocknot's Ale instance quest shown in SG/BS at lvl 1
  [4295] = true,
  --The Gordok Ogre Suit dire maul isntance quest
  [5518] = true,
  [5519] = true,
  --aq40 raid quest
  [8595] = true,
  [8579] = true,
  --weekly fish tourney
  [8225] = true,
  [8221] = true,
  [8224] = true,
  [8225] = true,
  [8193] = true,
  [8226] = true,
  --Zinge's Assessment
  [8980] = true,
  --mount exchange/replacement
  [7678] = true,
  [7677] = true,
  [7673] = true,
  [7674] = true,
  [7671] = true,
  [7665] = true,
  [7675] = true,
  [7664] = true,
  [7672] = true,
  [7676] = true,
  --Wool/Silk/Mageweave/Runecloth donation
  [7791] = true,
  [7808] = true,
  [7835] = true,
  [7834] = true,
  [7831] = true,
  [7827] = true,
  [7824] = true,
  [7823] = true,
  [7822] = true,
  [7821] = true,
  [7818] = true,
  [7817] = true,
  [7814] = true,
  [7811] = true,
  [7809] = true,
  [7805] = true,
  [7792] = true,
  [7804] = true,
  [7803] = true,
  [7800] = true,
  [7799] = true,
  [7798] = true,
  [7795] = true,
  [7794] = true,
  [7793] = true,
  [7833] = true,
  [7826] = true,
  [7820] = true,
  [7813] = true,
  [7807] = true,
  [7802] = true,
  [7836] = true,
  --The Alliance Needs Your Help! shown for horde (aq40 quest in city. Maybe not needed?)
  [8795] = true,
  [8796] = true,
  [8797] = true,
  --Love Song for Narain //- Deep AQ scepter chain. Shown for all at 60
  [8599] = true,
  --Darkmoon Faire
  [7905] = true,
  [7926] = true,
  --Steamwheedle / Bloodsail reputation quests
  [9266] = true,
  [9259] = true,
  [9267] = true,
  [9272] = true,
  [1036] = true,
  [4621] = true,
  [9268] = true,
  --fishing tournament
  [8194] = true,
  [8193] = true,
  [8221] = true,
  [8224] = true,
  [8225] = true,
  [8193] = true,
  [8226] = true,
  [8228] = true,
  [8229] = true,
  --love is in the air
  [8981] = true,
  [8993] = true,
  [8982] = true,
  [9026] = true,
  [8983] = true,
  [9027] = true,
  [8900] = true,
  [8901] = true,
  [8902] = true,
  [9024] = true,
  [9025] = true,
  [8979] = true,
  --mount replacement
  [7662] = true,
  [7663] = true,
  [7660] = true,
  [7661] = true,
  --tier 0.5 bracers turn in
  [8905] = true,
  [8906] = true,
  [8907] = true,
  [8908] = true,
  [8909] = true,
  [8910] = true,
  [8911] = true,
  [8912] = true,
  [8913] = true,
  [8914] = true,
  [8915] = true,
  [8916] = true,
  [8917] = true,
  [8918] = true,
  [8919] = true,
  [8920] = true,

  -- plaguelands quests that arent in phase 1
  [5403] = true,
  [5407] = true,
  [5509] = true,
  [5510] = true,
  [5408] = true,
  [5402] = true,
  [5401] = true,
  [5405] = true,
  [5503] = true,
  [5404] = true,
  [5508] = true,
  [5406] = true,

  --PvP Warsong Gulch. Slay alliance/ slay horde shown for both alliance and horde
  [8290] = true,
  [7788] = true,
  [7871] = true,
  [7872] = true,
  [7873] = true,
  [8291] = true,
  [8295] = true,
  [7789] = true,
  [7874] = true,
  [7875] = true,
  [7876] = true,
  [8294] = true,
  --Brood of Nozdormu aq40 rep epic ring quest.
  [8747] = true,
  [8748] = true,
  [8749] = true,
  [8750] = true,
  [8752] = true,
  [8753] = true,
  [8754] = true,
  [8755] = true,
  [8757] = true,
  [8758] = true,
  [8759] = true,
  [8760] = true,
  --All PVP Quests
  [7385] = true,
  [7362] = true,
  [7081] = true,
  [8080] = true,
  [8154] = true,
  [8155] = true,
  [8156] = true,
  [8297] = true,
  [8262] = true,
  [8260] = true,
  [8261] = true,
  [7223] = true,
  [8368] = true,
  [8389] = true,
  [8426] = true,
  [8427] = true,
  [8428] = true,
  [8429] = true,
  [8430] = true,
  [8431] = true,
  [8432] = true,
  [8433] = true,
  [8434] = true,
  [8435] = true,
  [6846] = true,
  [7281] = true,
  [7282] = true,
  [6825] = true,
  [6943] = true,
  [6826] = true,
  [6827] = true,
  [6942] = true,
  [6941] = true,
  [7122] = true,
  [7124] = true,
  [8374] = true,
  [8391] = true,
  [8392] = true,
  [8393] = true,
  [8394] = true,
  [8395] = true,
  [8396] = true,
  [8397] = true,
  [8398] = true,
  [5893] = true,
  [6982] = true,
  [8371] = true,
  [8385] = true,
  [8370] = true,
  [8390] = true,
  [8436] = true,
  [8437] = true,
  [8439] = true,
  [8440] = true,
  [8441] = true,
  [8442] = true,
  [8443] = true,
  [8115] = true,
  [8114] = true,
  [7386] = true,
  [8123] = true,
  [8160] = true,
  [8161] = true,
  [8162] = true,
  [8299] = true,
  [7421] = true,
  [8265] = true,
  [8263] = true,
  [8264] = true,
  [7367] = true,
  [7368] = true,
  [7165] = true,
  [7170] = true,
  [7001] = true,
  [7027] = true,
  [7224] = true,
  [7301] = true,
  [7302] = true,
  [7361] = true,
  [8372] = true,
  [8386] = true,
  [8399] = true,
  [8400] = true,
  [8401] = true,
  [8402] = true,
  [8403] = true,
  [8404] = true,
  [8405] = true,
  [8406] = true,
  [8407] = true,
  [8408] = true,
  [8367] = true,
  [8388] = true,
  [7364] = true,
  [8272] = true,
  [8271] = true,
  [7164] = true,
  [7169] = true,
  [7423] = true,
  [7241] = true,
  [8369] = true,
  [5892] = true,
  [6985] = true,
  [6881] = true,
  [7202] = true,
  [7382] = true,
  [6901] = true,
  [7166] = true,
  [7171] = true,
  [6801] = true,
  [7922] = true,
  [7923] = true,
  [7924] = true,
  [7925] = true,
  [8293] = true,
  [6847] = true,
  [6848] = true,
  [6781] = true,
  [6741] = true,
  [8081] = true,
  [8124] = true,
  [8157] = true,
  [8158] = true,
  [8159] = true,
  [8163] = true,
  [8164] = true,
  [8165] = true,
  [8298] = true,
  [8300] = true,
  [7426] = true,
  [7161] = true,
  [7162] = true,
  [7789] = true,
  [7874] = true,
  [7875] = true,
  [7876] = true,
  [8294] = true,
  [7002] = true,
  [7026] = true,
  [8266] = true,
  [8267] = true,
  [8268] = true,
  [8269] = true,
  [7163] = true,
  [7168] = true,
  [7123] = true,
  [7425] = true,
  [7365] = true,
  [8122] = true,
  [8121] = true,
  [7886] = true,
  [7887] = true,
  [7888] = true,
  [7921] = true,
  [8292] = true,
  [7366] = true,
  [7142] = true,
  [8105] = true,
  [8120] = true,
  [8166] = true,
  [8167] = true,
  [8168] = true,
  [8169] = true,
  [8170] = true,
  [8171] = true,
  [7141] = true,
  [7167] = true,
  [7172] = true,
  [7082] = true,
  [7363] = true,
  [7181] = true,
  [7121] = true,
  [7381] = true,
  [7261] = true,
  [7101] = true,
  [7102] = true,
  [7422] = true,
  [7788] = true,
  [7871] = true,
  [7872] = true,
  [7873] = true,
  [8291] = true,
  [7401] = true,
  [7427] = true,
  [7428] = true,
  [7402] = true,
  [7424] = true,
  [6861] = true,
  [6862] = true,
  [8001] = true,
  --More pvp quests ?? strange Ones
  [8387] = true,
  [8375] = true,
  [8383] = true,
  [8438] = true,
  [8384] = true,
  [7863] = true,
  [7864] = true,
  [7865] = true,
  [7866] = true,
  [7867] = true,
  [7868] = true,


  -- corrupted windblossom
  [2523] = true,
  [2878] = true,
  [3363] = true,
  [4113] = true,
  [4114] = true,
  [4116] = true,
  [4118] = true,
  [4401] = true,
  [4464] = true,
  [4465] = true,
  [996] = true,
  [998] = true,
  [1514] = true,
  [4115] = true,
  [4221] = true,
  [4222] = true,
  [4343] = true,
  [4403] = true,
  [4466] = true,
  [4467] = true,
  [4117] = true,
  [4443] = true,
  [4444] = true,
  [4445] = true,
  [4446] = true,
  [4461] = true,
  [4117] = true,
  [4443] = true,
  [4444] = true,
  [4445] = true,
  [4446] = true,
  [4461] = true,
  [4119] = true,
  [4447] = true,
  [4448] = true,
  [4462] = true,
  --Phase 2 - Dire Maul
  [8250] = true,
  [7494] = true,
  [7441] = true,
  [7492] = true,
  [7581] = true,
  [7582] = true,
  [1193] = true,
  [1318] = true,
  [5518] = true,
  [5519] = true,
  [5525] = true,
  [5528] = true,
  [7429] = true,
  [7461] = true,
  [7462] = true,
  [7463] = true,
  [7463] = true,
  [7483] = true,
  [7484] = true,
  [7485] = true,
  [7507] = true,
  [7508] = true,
  [7509] = true,
  [7649] = true,
  [7650] = true,
  [7651] = true,
  [7481] = true,
  [7482] = true,
  [7703] = true,
  [7877] = true,
--Phase 4 - Zul'Gurub
  [8056] = true,
  [8057] = true,
  [8064] = true,
  [8065] = true,
  [8074] = true,
  [8075] = true,
  [8110] = true,
  [8111] = true,
  [8112] = true,
  [8113] = true,
  [8116] = true,
  [8117] = true,
  [8118] = true,
  [8119] = true,
  [8041] = true,
  [8042] = true,
  [8043] = true,
  [8044] = true,
  [8045] = true,
  [8046] = true,
  [8047] = true,
  [8048] = true,
  [8049] = true,
  [8050] = true,
  [8051] = true,
  [8052] = true,
  [8053] = true,
  [8054] = true,
  [8055] = true,
  [8058] = true,
  [8059] = true,
  [8060] = true,
  [8061] = true,
  [8062] = true,
  [8063] = true,
  [8066] = true,
  [8067] = true,
  [8068] = true,
  [8069] = true,
  [8070] = true,
  [8071] = true,
  [8072] = true,
  [8073] = true,
  [8076] = true,
  [8077] = true,
  [8078] = true,
  [8079] = true,
  [8101] = true,
  [8102] = true,
  [8103] = true,
  [8104] = true,
  [8106] = true,
  [8107] = true,
  [8108] = true,
  [8109] = true,
  [8141] = true,
  [8142] = true,
  [8143] = true,
  [8144] = true,
  [8145] = true,
  [8146] = true,
  [8147] = true,
  [8148] = true,
  [8184] = true,
  [8185] = true,
  [8186] = true,
  [8187] = true,
  [8188] = true,
  [8189] = true,
  [8190] = true,
  [8191] = true,
  [8192] = true,
  [8195] = true,
  [8196] = true,
  [8201] = true,
  [8227] = true,
  [8238] = true,
  [8239] = true,
  [8240] = true,
  [8243] = true,
  [8246] = true,
  [9208] = true,
  [9209] = true,
  [9210] = true,
--Phase 5 - AQ20/AQ40/AQ War Effort
  [8254] = true,
  [8275] = true,
  [8276] = true,
  [8304] = true,
  [8343] = true,
  [8331] = true,
  [8320] = true,
  [8361] = true,
  [9338] = true,
  [9023] = true,
  [9248] = true,
  [9422] = true,
  [8280] = true,
  [8277] = true,
  [8283] = true,
  [8284] = true,
  [8318] = true,
  [8286] = true,
  [8288] = true,
  [8301] = true,
  [8302] = true,
  [8303] = true,
  [8305] = true,
  [8492] = true,
  [8493] = true,
  [8494] = true,
  [8495] = true,
  [8496] = true,
  [8499] = true,
  [8500] = true,
  [8503] = true,
  [8504] = true,
  [8505] = true,
  [8506] = true,
  [8509] = true,
  [8510] = true,
  [8511] = true,
  [8512] = true,
  [8513] = true,
  [8514] = true,
  [8515] = true,
  [8516] = true,
  [8517] = true,
  [8518] = true,
  [8519] = true,
  [8520] = true,
  [8521] = true,
  [8522] = true,
  [8523] = true,
  [8524] = true,
  [8525] = true,
  [8526] = true,
  [8527] = true,
  [8528] = true,
  [8529] = true,
  [8532] = true,
  [8533] = true,
  [8542] = true,
  [8543] = true,
  [8544] = true,
  [8545] = true,
  [8546] = true,
  [8548] = true,
  [8549] = true,
  [8550] = true,
  [8555] = true,
  [8556] = true,
  [8557] = true,
  [8558] = true,
  [8559] = true,
  [8560] = true,
  [8561] = true,
  [8562] = true,
  [8572] = true,
  [8573] = true,
  [8574] = true,
  [8575] = true,
  [8576] = true,
  [8577] = true,
  [8578] = true,
  [8579] = true,
  [8580] = true,
  [8581] = true,
  [8582] = true,
  [8583] = true,
  [8587] = true,
  [8588] = true,
  [8589] = true,
  [8590] = true,
  [8591] = true,
  [8592] = true,
  [8593] = true,
  [8594] = true,
  [8595] = true,
  [8596] = true,
  [8597] = true,
  [8598] = true,
  [8599] = true,
  [8600] = true,
  [8601] = true,
  [8602] = true,
  [8603] = true,
  [8604] = true,
  [8605] = true,
  [8606] = true,
  [8607] = true,
  [8608] = true,
  [8609] = true,
  [8610] = true,
  [8611] = true,
  [8612] = true,
  [8613] = true,
  [8614] = true,
  [8615] = true,
  [8616] = true,
  [8620] = true,
  [8621] = true,
  [8622] = true,
  [8623] = true,
  [8624] = true,
  [8625] = true,
  [8626] = true,
  [8627] = true,
  [8628] = true,
  [8629] = true,
  [8630] = true,
  [8631] = true,
  [8632] = true,
  [8633] = true,
  [8634] = true,
  [8637] = true,
  [8638] = true,
  [8639] = true,
  [8640] = true,
  [8641] = true,
  [8655] = true,
  [8656] = true,
  [8657] = true,
  [8658] = true,
  [8659] = true,
  [8660] = true,
  [8661] = true,
  [8662] = true,
  [8663] = true,
  [8664] = true,
  [8665] = true,
  [8666] = true,
  [8667] = true,
  [8668] = true,
  [8669] = true,
  [8689] = true,
  [8690] = true,
  [8691] = true,
  [8692] = true,
  [8693] = true,
  [8694] = true,
  [8695] = true,
  [8696] = true,
  [8697] = true,
  [8698] = true,
  [8699] = true,
  [8700] = true,
  [8701] = true,
  [8702] = true,
  [8703] = true,
  [8704] = true,
  [8705] = true,
  [8706] = true,
  [8707] = true,
  [8708] = true,
  [8709] = true,
  [8710] = true,
  [8711] = true,
  [8712] = true,
  [8728] = true,
  [8729] = true,
  [8730] = true,
  [8733] = true,
  [8734] = true,
  [8735] = true,
  [8736] = true,
  [8741] = true,
  [8742] = true,
  [8743] = true,
  [8745] = true,
  [8747] = true,
  [8748] = true,
  [8749] = true,
  [8750] = true,
  [8751] = true,
  [8752] = true,
  [8753] = true,
  [8754] = true,
  [8755] = true,
  [8756] = true,
  [8757] = true,
  [8758] = true,
  [8759] = true,
  [8760] = true,
  [8761] = true,
  [8783] = true,
  [8784] = true,
  [8789] = true,
  [8790] = true,
  [8791] = true,
  [8792] = true,
  [8793] = true,
  [8794] = true,
  [8795] = true,
  [8796] = true,
  [8797] = true,
  [8800] = true,
  [8801] = true,
  [8802] = true,
  [8846] = true,
  [8847] = true,
  [8848] = true,
  [8849] = true,
  [8850] = true,
  [9250] = true,
  [9251] = true,
  [8764] = true,
  [8765] = true,
  [8766] = true,
--Phase 6 - Naxxramas
  [9141] = true,
  [9033] = true,
  [9034] = true,
  [9036] = true,
  [9037] = true,
  [9038] = true,
  [9039] = true,
  [9040] = true,
  [9041] = true,
  [9042] = true,
  [9043] = true,
  [9044] = true,
  [9045] = true,
  [9046] = true,
  [9047] = true,
  [9048] = true,
  [9049] = true,
  [9050] = true,
  [9054] = true,
  [9055] = true,
  [9056] = true,
  [9057] = true,
  [9058] = true,
  [9059] = true,
  [9060] = true,
  [9061] = true,
  [9068] = true,
  [9069] = true,
  [9070] = true,
  [9071] = true,
  [9072] = true,
  [9073] = true,
  [9074] = true,
  [9075] = true,
  [9077] = true,
  [9078] = true,
  [9079] = true,
  [9080] = true,
  [9081] = true,
  [9082] = true,
  [9083] = true,
  [9084] = true,
  [9086] = true,
  [9087] = true,
  [9088] = true,
  [9089] = true,
  [9090] = true,
  [9091] = true,
  [9092] = true,
  [9093] = true,
  [9095] = true,
  [9096] = true,
  [9097] = true,
  [9098] = true,
  [9099] = true,
  [9100] = true,
  [9101] = true,
  [9102] = true,
  [9103] = true,
  [9104] = true,
  [9105] = true,
  [9106] = true,
  [9107] = true,
  [9108] = true,
  [9109] = true,
  [9110] = true,
  [9111] = true,
  [9112] = true,
  [9113] = true,
  [9114] = true,
  [9115] = true,
  [9116] = true,
  [9117] = true,
  [9118] = true,
  [9120] = true,
  [9121] = true,
  [9122] = true,
  [9123] = true,
  [9124] = true,
  [9125] = true,
  [9126] = true,
  [9127] = true,
  [9128] = true,
  [9129] = true,
  [9131] = true,
  [9132] = true,
  [9136] = true,
  [9137] = true,
  [9211] = true,
  [9213] = true,
  [9221] = true,
  [9222] = true,
  [9223] = true,
  [9224] = true,
  [9225] = true,
  [9226] = true,
  [9227] = true,
  [9228] = true,
  [9229] = true,
  [9230] = true,
  [9232] = true,
  [9233] = true,
  [9234] = true,
  [9235] = true,
  [9236] = true,
  [9237] = true,
  [9238] = true,
  [9239] = true,
  [9240] = true,
  [9241] = true,
  [9242] = true,
  [9243] = true,
  [9244] = true,
  [9245] = true,
  [9246] = true,
  --Phase 6 - Silithus/EPL PvP
  [9664] = true,
  [9415] = true,
  [8731] = true,
  [8507] = true,
  [8732] = true,
  [8508] = true,
  [9419] = true,
  [9416] = true,
  [9665] = true,
}
